/*
 * cpumsr.C
 */

#include	<basic.h>
#include	<bstdio.h>
#include	<inner.h>
#include	<errcode.h>
#include	<driver/driver.h>
#include	<driver/pcat/sys.h>

#define	DEFAULTPRI	80
#define	STACKSIZE	2048

#ifdef	DEBUG
#define	DP(x)	printf x
#else
#define	DP(x)	/* */
#endif

LOCAL	ID	Porid;


/* ɥ쥹֤ڤؤȥåPMCΥɤήѡ */
LOCAL	ERR	setAndCheckTaskSpace(DevReq *devReq)
{
    ERR	err;

    if(devReq->cmd.adcnv == 0 || devReq->datacnt <= 0) {
	err = ER_OK;
	goto fin;
    }
	
    /* ɥ쥹֤ */
    err = SetTaskSpace(devReq->taskid);
    if(err != ER_OK) {
	DP(("SetTaskSpace err = %d\n", err));
	goto fin;
    }

    /* ɥ쥹֤Υå */
    if(devReq->cmd.cmd == DC_READ) {
	/* READäƤȤϡƤӽФ¦Υ˽񤭹äƤ */
	err = CheckSpaceRW(devReq->memptr, devReq->datacnt);
    } else {
	err = CheckSpaceR(devReq->memptr, devReq->datacnt);
    }

    if(err != ER_OK) {
	DP(("CheckSpace err = %d\n", err));
	goto fin;
    }

    err = ER_OK;
 fin:
    return err;
}


/* MSR쥸 */
LOCAL	VOID	io_msr(UW idx, UW *ptr, W mode)
{
    UW	eflags;

    DI(eflags);

    switch(mode) {
    case	DC_READ:
	Asm("rdmsr" : "=eax" (ptr[0]), "=edx" (ptr[1]) : "ecx" (idx));
	break;

    case	DC_WRITE:
	Asm("wrmsr" : : "eax" (ptr[0]), "edx" (ptr[1]), "ecx" (idx));
	break;

    default:
	break;
    }

    EI(eflags);

    return;
}


/* ɥ饤С׵ */
LOCAL	ERR	io_ExecRequest(DevReq *devreq, DevRsp *devrsp)
{
    ERR	err = ER_OK;

    /* μ¹ԡREAD/WRITEʳϲ⤷ʤ */
    switch(devreq->cmd.cmd) {
    case	DC_READ:
    case	DC_WRITE:
	err = setAndCheckTaskSpace(devreq);	/* ֤ƽ¦ */

	if(err < 0) break;

	if(devreq->datacnt < 8) err = ER_NOSPC;
	else io_msr(devreq->datano, devreq->memptr, devreq->cmd.cmd);

	devrsp->datacnt = 8;
	break;

    case	DC_OPEN:
    case	DC_CLOSE:
    case	DC_CLOSEALL:

    case	DC_ABORT:
    case	DC_SUSPEND:
    case	DC_RESUME:
    case	DC_CARDEVENT:
	break;

    default:
	err = ER_NOSPT;
	break;
    }

    return(err);
}


/* ᥤ󥿥 */
LOCAL	VOID	io_maintask(ID porid)
{
    ERR	err;
    RNO	rdvno;
    W	size;
    DevReq	devreq;
    DevRsp	devrsp;

    while(1) {
	/* ׵Ԥ */
	err = acp_por(&rdvno, (VP)&devreq, &size,
		      porid, D_ABORT_PTN | D_NORM_PTN);
	if(err < 0) goto fin;

	/* ΰۤʤѥåȤ̵ */
	if(size != sizeof(DevReq)) {
	    DP(("io_maintask(): bad packet size (%d)\n", size));
	    continue;
	}

	/* ѥѥåȤν׵μ¹ */
	devrsp.devid     = devreq.devid;
	devrsp.cmd       = devreq.cmd;
	devrsp.datano    = devreq.datano;
	devrsp.datacnt   = 0;
	devrsp.error.err = io_ExecRequest(&devreq, &devrsp);

	/* ǥ֤ؤ */
	err = rpl_rdv(rdvno, (VP)&devrsp, sizeof(DevRsp));
	if(err < 0) DP(("io_maintask(): rpl_por() failed(%d)\n", err));
    }

    /* ϿǥХ̾äʤȤʤΤ */
 fin:
    del_por(porid);
    exd_tsk();
}


/* ɥ饤ФΥȥݥ */
EXPORT	ERR	main(Bool startup, TC *arg)
{
    T_CPOR	cpor;
    T_CTSK	ctsk;
    ERR	err;
    ID	tskid;

    DevDef	devdef = {
	{0},			/* °ʸꤹ */
	0,			/* ֥˥åȡ̵Τ0 */
	{L""},	/* ǥХ̾ */
	0			/* ǥ֥ݡIDʸ */
    };

    /* λ׵ */
    if(!startup) {
	err = del_por(Porid);
	goto fin0;
    }

    /* ǥ֥ݡȺ */
    cpor.exinf   = NULL;
    cpor.poratr  = TA_NULL;
    cpor.maxcmsz = sizeof(DevReq);
    cpor.maxrmsz = sizeof(DevRsp);

    err = vcre_por(&cpor);
    if(err < 0) {
	DP(("main(): vcre_por(): %d\n", err));
	goto	fin0;
    }
    Porid = (ID) err;

    /* դ */
    ctsk.exinf   = NULL;
    ctsk.task    = io_maintask;
    ctsk.itskpri = DEFAULTPRI;
    ctsk.stksz   = STACKSIZE;
    ctsk.tskatr  = TA_HLNG | TA_RNG0;

    err = vcre_tsk(&ctsk);
    if(err < 0) {
	DP(("main(): vcre_tsk(): %d\n", err));
	goto	fin1;
    }
    tskid = (ID) err;

    /* ǥХ°ꤪϿ */
    devdef.attr.devinfo  = 0;		/* äꤷʤ */
    devdef.attr.devkind  = DK_UNDEF;	/* ̤ */
    devdef.attr.reserved = 0;		/* ͽ(0) */
    devdef.attr.openreq  = 1;		/* open/close׵ͭ */
    devdef.attr.lockreq  = 0;		/* lock */
    devdef.attr.diskinfo = 0;		/* DN_DISKINO̤б */
    devdef.attr.chardev  = 1;		/* ʸǥХ */
    devdef.attr.nowait   = 0;		/* nowait⡼б */
    devdef.attr.eject    = 0;		/* eject */

    devdef.portid        = Porid;	/* ǥ֥ݡID */

    err = DefDevice(&devdef, NULL);
    if(err < 0) {
	DP(("main(): DefDevice(): %d\n", err));
	goto	fin2;
    }

    /* դư */
    err = sta_tsk(tskid, Porid);
    if(err < 0) {
	DP(("main(): sta_tsk(): %d\n", err));
	goto	fin3;
    }

    err = ER_OK;
    goto	fin0;

    /*  */
/* fin4: */
    ter_tsk(tskid);
fin3:
    devdef.portid = 0;
    DefDevice(&devdef, NULL);
fin2:
    del_tsk(tskid);
fin1:
    del_por(Porid);
fin0:
    return err;
}
